The xdg_positioner interface

The xdg_positioner provides a collection of rules for the placement of a child surface relative to a parent surface. Rules can be defined to ensure the child surface remains within the visible area's borders, and to specify how the child surface changes its position, such as sliding along an axis, or flipping around a rectangle. These positioner-created rules are constrained by the requirement that a child surface must intersect with or be at least partially adjacent to its parent surface. More...

## Macros

#define | XDG_POSITIONER_DESTROY_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_SIZE_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_ANCHOR_RECT_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_ANCHOR_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_GRAVITY_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION 1
#define | XDG_POSITIONER_SET_OFFSET_SINCE_VERSION 1

## Enumerations

enum | xdg_positioner_constraint_adjustment { XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE = 0, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X = 1, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y = 2, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X = 4, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y = 8, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X = 16, XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y = 32 }

## Functions

static void | xdg_positioner_set_user_data (struct xdg_positioner *xdg_positioner, void *user_data)
static void * | xdg_positioner_get_user_data (struct xdg_positioner *xdg_positioner)
static void | xdg_positioner_destroy (struct xdg_positioner *xdg_positioner)
static void | xdg_positioner_set_size (struct xdg_positioner *xdg_positioner, int32_t width, int32_t height)
static void | xdg_positioner_set_anchor_rect (struct xdg_positioner *xdg_positioner, int32_t x, int32_t y, int32_t width, int32_t height)
static void | xdg_positioner_set_anchor (struct xdg_positioner *xdg_positioner, uint32_t anchor)
static void | xdg_positioner_set_gravity (struct xdg_positioner *xdg_positioner, uint32_t gravity)
static void | xdg_positioner_set_constraint_adjustment (struct xdg_positioner *xdg_positioner, uint32_t constraint_adjustment)
static void | xdg_positioner_set_offset (struct xdg_positioner *xdg_positioner, int32_t x, int32_t y)

## Detailed Description

The xdg_positioner provides a collection of rules for the placement of a child surface relative to a parent surface. Rules can be defined to ensure the child surface remains within the visible area's borders, and to specify how the child surface changes its position, such as sliding along an axis, or flipping around a rectangle. These positioner-created rules are constrained by the requirement that a child surface must intersect with or be at least partially adjacent to its parent surface.

See the various requests for details about possible rules.

At the time of the request, the compositor makes a copy of the rules specified by the xdg_positioner. Thus, after the request is complete the xdg_positioner object can be destroyed or reused; further changes to the object will have no effect on previous usages.

For an xdg_positioner object to be considered complete, it must have a non-zero size set by set_size, and a non-zero anchor rectangle set by set_anchor_rect. Passing an incomplete xdg_positioner object when positioning a surface raises an error.

## Macro Definition Documentation

## XDG_POSITIONER_DESTROY_SINCE_VERSION

#define XDG_POSITIONER_DESTROY_SINCE_VERSION 1

Definition at line 601 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_ANCHOR_RECT_SINCE_VERSION

#define XDG_POSITIONER_SET_ANCHOR_RECT_SINCE_VERSION 1

Definition at line 609 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_ANCHOR_SINCE_VERSION

#define XDG_POSITIONER_SET_ANCHOR_SINCE_VERSION 1

Definition at line 613 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION

#define XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION 1

Definition at line 621 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_GRAVITY_SINCE_VERSION

#define XDG_POSITIONER_SET_GRAVITY_SINCE_VERSION 1

Definition at line 617 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_OFFSET_SINCE_VERSION

#define XDG_POSITIONER_SET_OFFSET_SINCE_VERSION 1

Definition at line 625 of file xdg-shell-client-protocol.h.

## XDG_POSITIONER_SET_SIZE_SINCE_VERSION

#define XDG_POSITIONER_SET_SIZE_SINCE_VERSION 1

Definition at line 605 of file xdg-shell-client-protocol.h.

## Enumeration Type Documentation

## xdg_positioner_constraint_adjustment

enum xdg_positioner_constraint_adjustment

vertically resize the surface

Resize the surface vertically so that it is completely unconstrained.

Enumerator
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X |
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y |

Definition at line 578 of file xdg-shell-client-protocol.h.

{
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE = 0,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X = 1,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y = 2,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X = 4,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y = 8,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X = 16,
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y = 32,
};

## Function Documentation

## xdg_positioner_destroy()

static void xdg_positioner_destroy | ( | struct xdg_positioner * | xdg_positioner | ) |

inline static

Notify the compositor that the xdg_positioner will no longer be used.

Definition at line 653 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_DESTROY);
wl_proxy_destroy((struct wl_proxy *) xdg_positioner);
}

References XDG_POSITIONER_DESTROY.

## xdg_positioner_get_user_data()

static void* xdg_positioner_get_user_data | ( | struct xdg_positioner * | xdg_positioner | ) |

inline static

Definition at line 636 of file xdg-shell-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) xdg_positioner);
}

## xdg_positioner_set_anchor()

static void xdg_positioner_set_anchor | ( | struct xdg_positioner * | xdg_positioner,
|  | uint32_t | anchor
| ) |  |

inline static

Defines the anchor point for the anchor rectangle. The specified anchor is used derive an anchor point that the child surface will be positioned relative to. If a corner anchor is set (e.g. 'top_left' or 'bottom_right'), the anchor point will be at the specified corner; otherwise, the derived anchor point will be centered on the specified edge, or in the center of the anchor rectangle if no edge is specified.

Definition at line 709 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_ANCHOR, anchor);
}

References XDG_POSITIONER_SET_ANCHOR.

## xdg_positioner_set_anchor_rect()

static void xdg_positioner_set_anchor_rect | ( | struct xdg_positioner * | xdg_positioner,
|  | int32_t | x,
|  | int32_t | y,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Specify the anchor rectangle within the parent surface that the child surface will be placed relative to. The rectangle is relative to the window geometry as defined by xdg_surface.set_window_geometry of the parent surface.

When the xdg_positioner object is used to position a child surface, the anchor rectangle may not extend outside the window geometry of the positioned child's parent surface.

If a negative size is set the invalid_input error is raised.

Definition at line 692 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_ANCHOR_RECT, x, y, width, height);
}

References XDG_POSITIONER_SET_ANCHOR_RECT.

## xdg_positioner_set_constraint_adjustment()

static void xdg_positioner_set_constraint_adjustment | ( | struct xdg_positioner * | xdg_positioner,
|  | uint32_t | constraint_adjustment
| ) |  |

inline static

Specify how the window should be positioned if the originally intended position caused the surface to be constrained, meaning at least partially outside positioning boundaries set by the compositor. The adjustment is set by constructing a bitmask describing the adjustment to be made when the surface is constrained on that axis.

If no bit for one axis is set, the compositor will assume that the child surface should not change its position on that axis when constrained.

If more than one bit for one axis is set, the order of how adjustments are applied is specified in the corresponding adjustment descriptions.

The default adjustment is none.

Definition at line 750 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT, constraint_adjustment);
}

References XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT.

## xdg_positioner_set_gravity()

static void xdg_positioner_set_gravity | ( | struct xdg_positioner * | xdg_positioner,
|  | uint32_t | gravity
| ) |  |

inline static

Defines in what direction a surface should be positioned, relative to the anchor point of the parent surface. If a corner gravity is specified (e.g. 'bottom_right' or 'top_left'), then the child surface will be placed towards the specified gravity; otherwise, the child surface will be centered over the anchor point on any axis that had no gravity specified.

Definition at line 726 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_GRAVITY, gravity);
}

References XDG_POSITIONER_SET_GRAVITY.

## xdg_positioner_set_offset()

static void xdg_positioner_set_offset | ( | struct xdg_positioner * | xdg_positioner,
|  | int32_t | x,
|  | int32_t | y
| ) |  |

inline static

Specify the surface position offset relative to the position of the anchor on the anchor rectangle and the anchor on the surface. For example if the anchor of the anchor rectangle is at (x, y), the surface has the gravity bottom|right, and the offset is (ox, oy), the calculated surface position will be (x + ox, y + oy). The offset position of the surface is the one used for constraint testing. See set_constraint_adjustment.

An example use case is placing a popup menu on top of a user interface element, while aligning the user interface element of the parent surface with some user interface element placed somewhere in the popup surface.

Definition at line 772 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_OFFSET, x, y);
}

References XDG_POSITIONER_SET_OFFSET.

## xdg_positioner_set_size()

static void xdg_positioner_set_size | ( | struct xdg_positioner * | xdg_positioner,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Set the size of the surface that is to be positioned with the positioner object. The size is in surface-local coordinates and corresponds to the window geometry. See xdg_surface.set_window_geometry.

If a zero or negative size is set the invalid_input error is raised.

Definition at line 671 of file xdg-shell-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) xdg_positioner,
XDG_POSITIONER_SET_SIZE, width, height);
}

References XDG_POSITIONER_SET_SIZE.

## xdg_positioner_set_user_data()

static void xdg_positioner_set_user_data | ( | struct xdg_positioner * | xdg_positioner,
|  | void * | user_data
| ) |  |

inline static

Definition at line 629 of file xdg-shell-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) xdg_positioner, user_data);
}
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y
Definition: xdg-shell-client-protocol.h:581
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X
Definition: xdg-shell-client-protocol.h:580
width
GLint GLint GLsizei width
Definition: SDL_opengl.h:1572
XDG_POSITIONER_SET_SIZE
#define XDG_POSITIONER_SET_SIZE
Definition: xdg-shell-client-protocol.h:590
XDG_POSITIONER_SET_ANCHOR_RECT
#define XDG_POSITIONER_SET_ANCHOR_RECT
Definition: xdg-shell-client-protocol.h:591
XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT
#define XDG_POSITIONER_SET_CONSTRAINT_ADJUSTMENT
Definition: xdg-shell-client-protocol.h:594
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
XDG_POSITIONER_DESTROY
#define XDG_POSITIONER_DESTROY
Definition: xdg-shell-client-protocol.h:589
XDG_POSITIONER_SET_GRAVITY
#define XDG_POSITIONER_SET_GRAVITY
Definition: xdg-shell-client-protocol.h:593
height
GLint GLint GLsizei GLsizei height
Definition: SDL_opengl.h:1572
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE
Definition: xdg-shell-client-protocol.h:579
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X
Definition: xdg-shell-client-protocol.h:584
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X
Definition: xdg-shell-client-protocol.h:582
XDG_POSITIONER_SET_ANCHOR
#define XDG_POSITIONER_SET_ANCHOR
Definition: xdg-shell-client-protocol.h:592
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y
Definition: xdg-shell-client-protocol.h:583
XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y
@ XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y
Definition: xdg-shell-client-protocol.h:585
XDG_POSITIONER_SET_OFFSET
#define XDG_POSITIONER_SET_OFFSET
Definition: xdg-shell-client-protocol.h:595